<?php
//	epsilonwiki_php | copyleft_GPL alainmarty
//	fichier appelé par index.php ou par AJAX
//////////////////////////////
include( "strings.php" );	// 	constantes pour l'internationalisation
new wiki();					//	création du wiki
//////////////////////////////

class wiki
{	var $state;
	function wiki()
	{	$this->state = $this->getLogin();
		if (isset($_GET['preview']))	
			echo $this->doPreview('');	// connexion AJAX, régénération du bloc #preview
		else								
			echo $this->doHTML();		// calcule et affiche la page HTML
	}
	function doPreview( $texte )
	{	if (isset($_POST['texte']))
			$texte = $_POST['texte'];
		$texte = $this->doControlContent( $texte );
		$texte = $this->doSyntax($texte);
		return $texte;
	}
	function doHTML()
	{	// $template = MECA_DIR.SKINS_DIR.STYLE.'/template.html';
		// correction 23/08/2007 :
		$style = (isset($_COOKIE[LOGIN_COOKIE.'_skin']))? $_COOKIE[LOGIN_COOKIE.'_skin'] : STYLE;
		$template = MECA_DIR.SKINS_DIR.$style.'/template.html';
		if (!(file_exists($template) && ($html = file_get_contents($template)) )) return 'no template';
		$html = preg_replace('/{METAS}/', 			METAS, $html);
		$html = preg_replace('/{INDEX_FOLLOW}/', 	$this->doIndexFollow(), $html);
		$html = preg_replace('/{STYLES}/', 			$this->doStyles(), $html);
		$html = preg_replace('/{SCRIPTS}/', 		$this->doScripts(), $html);
		$html = preg_replace('/{RSS}/', 			$this->doLinkRSS(), $html);
		$wiki_action = $this->getAction();
		$html = preg_replace('/{TITLE}/', 			$wiki_action->doTitle(false), $html);
		$html = preg_replace('/{HEAD}/', 			$wiki_action->doTitle(true), $html);
		$html = preg_replace('/{MENU}/', 			$wiki_action->doMenu(), $html);
		$html = preg_replace('/{CONTENT}/', 		$wiki_action->doContent() , $html);
		$html = preg_replace('/{FOOT}/', 			$wiki_action->doFoot(), $html);
		return $html;
	}
	function doIndexFollow() 
	{ 	return '<meta name="robots" content="'.INDEX.','.FOLLOW.'" />'; 
	}
	function doScripts() 
	{ 	$chaine = '<script type="text/javascript" language="javascript" src="'.MECA_DIR.'scripts.js"></script>'; 
		if (true)		// effet Lightbox nécessitant la présence du dossier lightbox à la racine (index.php)
		{	$chaine .= '<script src="lightbox/js/prototype.js" type="text/javascript"></script>';
			$chaine .= '<script src="lightbox/js/scriptaculous.js?load=effects" type="text/javascript"></script>';
			$chaine .= '<script src="lightbox/js/lightbox.js" type="text/javascript"></script>';
			$chaine .= '<link rel="stylesheet" href="lightbox/css/lightbox.css" type="text/css" media="screen" />';
		}
		return $chaine;
	}
	function doStyles() 
	{ 	$skin = (isset($_COOKIE[LOGIN_COOKIE.'_skin']))? $this->doControlName($_COOKIE[LOGIN_COOKIE.'_skin']) : STYLE;
		return '<link type="text/css" rel="stylesheet" href="'.MECA_DIR.SKINS_DIR.$skin.'/styles.css" />'; 		
		// modif proposée par jipi 03/03/2008 3 lignes suivantes
	//	$mystyles =  '<link type="text/css" rel="stylesheet" href="'.MECA_DIR.SKINS_DIR.$skin.'/styles.css" />'; 
	//	$mystyles .= '<link type="image/x-icon" rel="shortcut icon" href="'.MECA_DIR.SKINS_DIR.$skin.'/favicon.ico" />';
	//	return $mystyles;
	}
	function doLinkRSS()
	{	if (!RSS_OK)
			$chaine = '';
		else
		{	$chaine = "http://".$_SERVER["HTTP_HOST"].preg_replace( "/index.php/","", $_SERVER["PHP_SELF"]).NEWS;
			$chaine = "<link rel=\"alternate\" title=\"fil RSS\" type=\"application/rss+xml\" href=\"".$chaine."\" />";
		}
		return $chaine;
	}
	function getAction()
	{		 if (isset($_GET['view']))					return new page_view($this, $this->doControlName($_GET['view']));
		else if (isset($_GET['edit']) && $this->state)	return new page_edit($this, $this->doControlName($_GET['edit']));
		else if (isset($_GET['save']) && $this->state)	return new page_save($this, $this->doControlName($_GET['save']));
		else if (isset($_GET['load']) && $this->state)	return new page_load($this, LOAD);
		else if (isset($_GET['skin']) && $this->state)	return new page_skin($this, SKIN);
		else if (isset($_GET['login']))					return new page_login($this, ($this->state)? LOGOUT : LOGIN );
		else if (isset($_GET['history']))				return new page_history($this, $this->doControlName($_GET['history']));
		else if (isset($_GET['search']))				return new page_search($this, $this->doControlName($_GET['search']));
		else if (isset($_GET['liste']))					return new page_liste($this, LISTE);
		else 											return new page_view($this, START);
	}
	function getLogin()			// gestion des autorisations 
	{	if (WIKI_LOCKED)		// wiki bloqué
			return false;		// le wiki n'est pas éditable, on sort !
		if (PASSWORD=='')		// le mot de passe n'est pas défini			
			return true;		// le wiki est éditable (avec test du cheval), on sort !
		if (isset($_COOKIE[LOGIN_COOKIE]))			// s'il existe un cookie contenant le mot de passe
		{	$crypted_password = $this->doControlName( $_COOKIE[LOGIN_COOKIE] );	// le contrôler
			if (CRYPTED_PASSWORD==$crypted_password)
				return true;	// le wiki est éditable (avec test du cheval), on sort !
			else
				return false;	// le wiki n'est pas éditable, on sort !
		}
		if	(	( isset($_GET['view']) && ( FORUM==$_GET['view'] || SANDBOX==$_GET['view'] ) ) ||
				( isset($_GET['edit']) && ( FORUM==$_GET['edit'] || SANDBOX==$_GET['edit'] ) ) ||
				( isset($_GET['save']) && ( FORUM==$_GET['save'] || SANDBOX==$_GET['save'] ) ) 
			)
			return true;		// les pages FORUM et SANDBOX sont éditables
		return false;			// tout autre cas (en principe inutile)
	}
	function doQuery( $search )	// champ de recherche
	{	$chaine = '<form style="display:inline;" method="get" action="index.php"><input type="submit" value="" />'
				.'<input style="border:1px solid #ccc;" type="text" name="search" value="'
				.$search.'" title="'.INFOBULLE_SEARCH.'" /></form>';
		return $chaine;
	}
	// fonctions de controle du nom de la page, du contenu et syntaxe wiki
	function doControlName( $chaine )
	{	$chaine = trim($chaine);								// supprime les espaces avant et après
		$chaine = stripslashes($chaine);						// supprime les anti-slash
		$chaine = strip_tags($chaine);							// supprime les balises HTML et PHP
		$chaine = preg_replace( '/\//', '', $chaine );			// supprime les slash
		$chaine = preg_replace("/(\.php)/i", '_php', $chaine );	// remplace .php par _php
		return $chaine;
	}
	function doControlContent( $chaine )
	{	$chaine = trim($chaine);								// supprime les espaces avant et après
		$chaine = stripslashes($chaine);						// supprime les anti-slash
		if (NO_HTML)											// le HTML/CSS n'est pas accepté
			$chaine = strip_tags($chaine);						// supprime les balises HTML et PHP
		else													// le HTML/CSS est accepté sauf :
			$chaine = preg_replace("/(<(script|form|\?|object|applet|embed))/i", 'SORRY', $chaine );
		$chaine .= "\n";										// pour reconstruire le dernier texte bloc éventuel
		return $chaine;
	}
	function doSyntax( $chaine )
	{	//	partie 1 du traitement de l'affichage des balises et du code (sauf [[...]]) 
		$chaine = preg_replace('/%%_/', '%%%', $chaine );
		$chaine = preg_replace('/%%_(.*?)\{(.*?)\}/', '_$1%%($2%%)', $chaine );
		$chaine = preg_replace_callback('/_pre\{\{(.*?)\}\}/is', array(&$this, 'print_code'), $chaine);	// noter les doubles accolades
		//	blocs sans problèmes d'imbrications : hx, p, ul, ol, //, [[...]]
		$chaine = preg_replace('/_(b|h)r\{\}/i', '<$1r />', $chaine);
		// à mettre au point !!! $chaine = preg_replace('/_(b|h)r\{*\}* /i', '<$1r />', $chaine);	// avec * ni accolades ni return 11/06/2008
		$chaine = preg_replace('/_h([1-6]) (.+?)\n/is', '<h$1>$2</h$1>'."\n", $chaine);
		$chaine = preg_replace('/_p (.*?)\n/is', '<p>$1</p>'."\n", $chaine);
	//	debut correction du 29/12/2007
	//	$chaine = preg_replace('/_(u|o)l([0-9]*?) (.+?)\n/i', '<$1l><li style="margin-left:$2px;">$3</li></$1l>', $chaine);
		$chaine = preg_replace('/_(u|o)l (.+?)\n/i', '<$1l><li>$2</li></$1l>', $chaine);
		$chaine = preg_replace('/_(u|o)l([0-9]+?) (.+?)\n/i', '<$1l><li style="margin-left:$2px;">$3</li></$1l>', $chaine);
	//	fin correction du 29/12/2007
		$chaine = preg_replace('/(<\/ol><ol>|<\/ul><ul>)/s', ''."\n", $chaine);
		$chaine = preg_replace('/_\/\/ (.+?)\n/is', '<!-- $1 -->', $chaine);
		$chaine = preg_replace('/\[\[([0-9a-zéèêëàâçùûüôö \.:#\'_-]+)\]\]/i', '<a href="?view=$1">$1</a>', $chaine);	// ôöûü ajouté le 27/10/2007
		$chaine = preg_replace('/\[\[([0-9a-zéèêëàâçùûüôö \.:#\'_-]+)\|(.+?)\]\]/i', '<a href="$2">$1</a>', $chaine);	// idem
		//	inlines au niveau terminal, traitées en premier : a, mailto, ancre, img, sound, video, embed, iframe, display, diapo
		$chaine = preg_replace('/_a\{([0-9a-zéèêëàâçù \.:#\'_-]+)\}/i', '<a href="?view=$1">$1</a>', $chaine);	// + et pas +?
		$chaine = preg_replace('/_mailto\{([^@\s]+@([-a-z0-9]+\.)+[a-z]{2,})\}/i', '<a href="mailto:$1">$1</a>', $chaine);
		$chaine = preg_replace('/_ancre\{([a-z0-9_#]+)\|([a-z0-9_#]+)\}/i', '<a name="$1" href="$2">$1</a>', $chaine );	// top à retravailler !!
		$chaine = preg_replace('/_img\{(.+?)\|([0-9]+?)\|(.+?)\}/i', '<img src="$1" height="$2" title="$3" alt="$3" border="0" />', $chaine);
		$chaine = preg_replace('/_sound\{(.+?)\|(false|true)\|(false|true)\}/i', '<embed src="$1" height="16" autostart="$2" loop="$3" />', $chaine);
		$chaine = preg_replace('/_video\{(.+?)\|(false|true)\|(false|true)\}/i', '<embed src="$1" autostart="$2" loop="$3" />', $chaine);
		$chaine = preg_replace('/_embed\{(.+?)\|([0-9]+?)\|([0-9]+?)\}/i', '<embed src="$1" width="$2" height="$3" />', $chaine);
		$chaine = preg_replace('/_iframe\{(.+?)\|([0-9]+?)\|([0-9]+?)\}/i', '<iframe src="$1" width="$2" height="$3"></iframe>', $chaine); // 04/02/2008 ajout fermeture ">" à </iframe , merci jipi
		$chaine = preg_replace_callback( '/_display\{([0-9a-zA-Z_]+?)\|(.+?)\|([0-9]+?)\}/is', array(&$this, 'init_display'), $chaine );
		$chaine = preg_replace_callback( '/_diapo\{([0-9a-zA-Z_]+?)\|(.+?)\|([0-9]+?)\}/is', array(&$this, 'init_diapo'), $chaine );
		$chaine = preg_replace_callback( '/_lightbox\{([0-9a-zA-Z_]+?)\|(.+?)\|([0-9]+?)\}/is', array(&$this, 'init_lightbox'), $chaine );
		//	inlines acceptant des inlines, traitées depuis les plus profondes (après les inlines)
		$balise = '_(a|div|span|b|i|u|table|tr|td|note|note_start|note_end|bloc|center|pre|p)\{';	// bloc et center obsolètes
		for($i=0; ereg($balise, $chaine) && $i<10; $i++)	// i<10 pour éviter une boucle infinie
		{	//	tant qu'il existe des formes "_balise{", remplacer à partir des plus profondes, (.+?) -> ([^{}]*?)
			$chaine = preg_replace('/_a\{([^{}]*?)\|([^{}]*?)\}/i', '<a href="$2">$1</a>', $chaine);	// ajouté images cliquables le 19/08/2007
			$chaine = preg_replace('/_(div|bloc)\{([^{}]*?)\|([^{}]*?)\}/is', '<div style="$2">$3</div>'."\n", $chaine);
			$chaine = preg_replace('/_span\{([^{}]*?)\|([^{}]*?)\}/is', '<span style="$1">$2</span>', $chaine);
		//	$chaine = preg_replace('/_(b|i|u|center|pre)\{([^{}]*?)\}/is', '<$1>$2</$1>', $chaine );
			$chaine = preg_replace('/_(b|i|u|center|pre|p)\{([^{}]*?)\}/is', '<$1>$2</$1>', $chaine );	// la forme _p{...} est autorisée 08/06/2008
			$chaine = preg_replace('/_table\{([^{}]*?)\}/is', '<table>$1</table>'."\n", $chaine);
			$chaine = preg_replace('/_tr\{([^{}]*?)\}/is', '<tr>$1</tr>', $chaine);
			$chaine = preg_replace('/_td\{(([^{}]*?)\|)?([^{}]*?)\}/is', '<td style="$2">$3</td>'."\n", $chaine);
//			$chaine = preg_replace('/_note\{([0-9a-z_ ]+?)\|([^{}]*?)\}/is', 
			$chaine = preg_replace('/_note\{([^{}]*?)\|([^{}]*?)\}/is',		// modifié le 02/10/2007 sur idée de pep
//					'<a href="javascript:montrer(\'$1\')">$1</a><span class="note" id="$1">$2</span>', $chaine);
					'<a href="javascript:montrer(\'_$1\')">$1</a><span class="note" id="_$1">$2</span>', $chaine);	// modif du 02/09/2007
			$chaine = preg_replace('/_note_start\{([0-9a-z_ ]+?)\|([^{}]*?)\}/i', '<a href="javascript:montrer(\'$1\')">$2</a>', $chaine);
			$chaine = preg_replace('/_note_end\{([0-9a-z_ ]+?)\|([^{}]*?)\}/is', '<span class="note" id="$1">$2</span>', $chaine);
		}
		//	partie 2 du traitement de l'affichage des balises et du code 
		$chaine = preg_replace('/%%\(/', '{', $chaine );
		$chaine = preg_replace('/%%\)/', '}', $chaine );
		$chaine = preg_replace('/%%%/', '_', $chaine );
		return $chaine;
	}
	// fonctions callback appelées par doSyntax ; encore en recherche de robustesse ...
	function init_lightbox( $matches )	// fonction callback appelée par preg_replace( _lightbox )
	{	$my_name = $matches[1];
		$tab = $matches[2];				// [ ["image","texte, avec virgule"],["image","texte"], ["image","texte"] ]
		$my_height = $matches[3];
		$tab = preg_replace( '/"/s', '', $tab);	// supprime les "
		preg_match_all( '/\[([^\[\]]*?)\]/s', $tab, $out );	// tableau des [image,texte]
		$tab = $out[1];
		$taille_my_picts = count($tab);
		$my_picts = array();
		for ($i=0; $i<$taille_my_picts; $i++)	// il doit y avoir plus simple !!!
		{	$temp = explode( ',', $tab[$i] );	// extraction de image et texte (facultatif)
			$nb = count($temp);
			$infobulle = '';
			for ($j=1; $j<$nb; $j++) { $infobulle .= trim($temp[$j]) .(($j!=$nb-1)? ', ' : '');  }
			$my_picts[$i]= array(trim($temp[0]) , $infobulle );
		}
		$chaine = '';
		for ($i=0; $i<$taille_my_picts; $i++)
		{	$chaine .= '<a href="' . $my_picts[$i][0] . '" onmouseover="' . $my_name . '.src=\'' . $my_picts[$i][0]; 
			$chaine .= '\'" rel="lightbox[roadtrip]" title="'.$my_picts[$i][1].'">';
			$chaine .= '<img src="' . $my_picts[$i][0] . '" width="16" height="16" border="0" alt="" /></a>';
		}
		if ($my_height==-1)
			$chaine .= '<br /><img src = "'.$my_picts[0][0].'" alt="" name="'.$my_name.'" />';
		else
			$chaine .= '<br /><img src = "'.$my_picts[0][0].'" alt="" name="'.$my_name.'" height="'. $my_height .'" />';
		return $chaine;
	}
	function init_display( $matches )	// fonction callback appelée par preg_replace( _display )
	{	$my_name = $matches[1];
		$tab = $matches[2];				// [ ["image","texte, avec virgule"],["image","texte"], ["image","texte"] ]
		$my_height = $matches[3];
		$tab = preg_replace( '/"/s', '', $tab);	// supprime les "
		preg_match_all( '/\[([^\[\]]*?)\]/s', $tab, $out );	// tableau des [image,texte]
		$tab = $out[1];
		$taille_my_picts = count($tab);
		$my_picts = array();
		for ($i=0; $i<$taille_my_picts; $i++)	// il doit y avoir plus simple !!!
		{	$temp = explode( ',', $tab[$i] );	// extraction de image et texte (facultatif)
			$nb = count($temp);
			$infobulle = '';
			for ($j=1; $j<$nb; $j++) { $infobulle .= trim($temp[$j]) .(($j!=$nb-1)? ', ' : '');  }
			$my_picts[$i]= array(trim($temp[0]) , $infobulle );
		}	
		$chaine = '<div id="fond_gris"></div><div id="fond_image"></div>';
		$chaine .= '<div style="position:absolute; visibility:hidden; top:-999em; left:0;">';	// amélioration du 13/08/2007
		for ($i=0; $i<$taille_my_picts; $i++)
		{
//	1		$the_name = $my_name . '|' . $i;
			$the_name = $my_name . 'à' . $i;	 // correction couplée avec scripts.css/display_montrer() du 02/09/2007
			$chaine .= '<img id="' . $the_name . '" src="' . $my_picts[$i][0] . '" alt="" title="' . $my_picts[$i][1] . '" />';
		}																			// ajouté alt="" 02/09/2007
		$chaine .= '</div>';
		for ($i=0; $i<$taille_my_picts; $i++)
		{
//	2		$the_name = $my_name . '|' . $i;
			$the_name = $my_name . 'à' . $i;	 // correction couplée avec scripts.css/display_montrer() du 02/09/2007
			$chaine .= '<a href="javascript:display_montrer(' . "'" . $the_name . "'" . ', true, ' . $taille_my_picts . ' )" '
					. 'onmouseover="' . $my_name . '.src=' . "'" . $my_picts[$i][0] . "'".'">'
					. '<img src="' . $my_picts[$i][0] . '" alt="" title="' . $my_picts[$i][1]	// ajouté alt="" 02/09/2007
				//	. '" style="height:16px;border:1px solid transparent;" /></a>';	// le 23/08/2007 remplacé par :
					. '" style="height:'.(($taille_my_picts==1)? $my_height : 16).'px;'
					. 'border-width:0px 1px 1px 0px;border-style:solid;border-color:transparent;" /></a>';
		}
		if ($taille_my_picts>1)	// amélioration du 23/08/2007
			$chaine .= '<br /><img src="' . $my_picts[0][0] . '" name="' . $my_name . '" border="0" height="' . $my_height . '" alt="" />';
		return $chaine;
	}
	function init_diapo( $matches )	// fonction callback appelée par preg_replace( _diapo )
	{	$my_name = $matches[1];
		$my_picts = $matches[2];	// [ ["image","texte"],["image","texte"], ["image","texte"] ]
		$my_picts = preg_replace( '/"/', "'", $my_picts );	// il faudrait recadrer les tableaux mal écrits !!!
		$my_time = $matches[3];
		$chaine = '<a href="javascript:start_diaporama('.$my_picts.','.$my_time.')">start</a>';
		$chaine .= ' | <a href="javascript:stop_diaporama()">stop</a>';
		$chaine .= '<div id="fond_diapo"></div>';
		return $chaine;	
	}
	function print_code( $matches )	// les $ ne sont pas acceptés, utiliser les € :)
	{	$chaine = $matches[1];
		$chaine = preg_replace( '/\{/', '%%(', $chaine );
		$chaine = preg_replace( '/\}/', '%%)', $chaine );
		return '<pre>'.$chaine.'</pre>';
	}

	// 	gestion des flux RSS, gestion du fichier news.xml
	function doRSS( $page, $content )							// appelée par page_save
	{	// 1) ouvrir le fichier news.xml
		$xml = $this->fichierTochaine( NEWS );
		$xml = trim( $xml );									// supprime les blancs au début et à la fin
		// 2) extraire un tableau $item
		$nbmsg = substr_count($xml, "<item>");					// compte le nombre de balises <item>
		for ($i=0; $i<$nbmsg; $i++)
		{	$temp = $this->extraction_balise( $xml, "<item>" );
			$item[$i] = $temp[0];
			$xml = substr( $xml, $temp[1] );	// on enlève le paquet <item>...</item> et au suivant ...
		}
		// 3) creer un nouvel item
			$content = RSS_PAGE_MODIF_START.$page.RSS_PAGE_MODIF_END;
			$new_item = "<item>\n";
			$new_item .= "<title>page ".$page." modif (".date("Y/m/d-H:i:s").")</title>\n";	// ce qui apparait dans le flux RSS Firefox 
			$new_item .= "<pubDate>".date("D, d M Y H:i:s +0100")."</pubDate>\n";
			$new_item .= "<description>".$content."</description>\n";
			$new_item .= "<link>http://".$_SERVER["HTTP_HOST"].$_SERVER["PHP_SELF"]."?view=".$page."</link>\n";
			$new_item .= "</item>";
		// 4) construire la chaine xml et enregistrer
		$xml = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<rss version=\"2.0\">\n<channel>\n<language>fr</language>\n";
		$xml .= "<title>".NOM_WIKI."'s news</title>\n<description>description</description>\n";
		$xml .= "<link>http://".$_SERVER["HTTP_HOST"].$_SERVER["PHP_SELF"]."</link>\n\n";
		$xml .= $new_item."\n\n";
		for ($i=0; $i<$nbmsg &&$i<20; $i++)		// liste limitée aux 20 derniers
			$xml .= "<item>".$item[$i]."</item>\n\n";
		$xml .= "</channel>\n</rss>";
		$this->chaineTofichier( $xml, NEWS );
	}	
	function fichierTochaine( $nom_fichier )
	{	$fichier = fopen($nom_fichier,"r") or die($php_errormsg);	
		$chaine = fread($fichier, filesize($nom_fichier));		
		fclose($fichier);
		return trim( $chaine );
	}
	function chaineTofichier( $chaine, $nom_fichier )
	{	$fichier = fopen($nom_fichier, "w") or die($php_errormsg);
		fwrite( $fichier, $chaine );
		fclose( $fichier ); 
	}
	function extraction_balise( $mmm, $balise )
	{	$start = strpos( $mmm, $balise ) + strLen( $balise );	// position de début <balise> + longueur <balise>
		$balise = "</".substr( $balise, 1 );					// construction de la balise de fin avec /					
		$end = strpos( $mmm, $balise );							// position de début </balise>
		$mess = substr( $mmm, $start, $end-$start );			// extraction du contenu <balise>[...]</balise>
		$long = $end + strLen( $balise );						// longueur de [<balise>...</balise>]
		return array($mess, $long);
	}
}
///////////////////////////////////////////////
// classes des actions du wiki (view, edit, save, ... )
class wiki_page
{	var $wiki;		// pointeur sur le wiki parent
	var $page;		// nom de la page
	function wiki_page( $wiki, $page )
	{	$this->wiki = $wiki;
		$this->page = $page;
	}
	function doTitle($active) 	
	{	$dots = ($active)? '<a href="?view='.START.'" title="'.INFOBULLE_BACK_START.'"> :: </a>' : ' :: ' ;
		return NOM_WIKI.$dots; 
	}
	function doMenu() 			
	{	return '<a href="?liste" title="'.INFOBULLE_LIST.'">liste</a> '.$this->wiki->doQuery('').'&nbsp;';	// &nbsp; 13/08/2007
	}
	function doContent() 		{	return 'hello from wiki_page'; }	// fonction traitée dans les classes descendantes
	function doFoot()
	{	if (PASSWORD=='' && !WIKI_LOCKED)
		{	$login = '----';	// inutile donc de proposer un login
			$load  = '<a href="?load" title="'.INFOBULLE_LOAD.'">load</a>';	
			$skin	= '<a href="?skin" title="'.INFOBULLE_SKIN.'">skin</a>';
			$instal = '<a href="http://amartyfree.free.fr/epsilonwiki/archive.zip" title="'.INFOBULLE_INSTAL.'">'.VERSION.'</a>';		
		}
		else
		{	$login	= ($this->wiki->state)? '<a href="?login" title="'.INFOBULLE_LOCK.'">logout</a>'
									: '<a href="?login" title="'.INFOBULLE_UNLOCK.'">login</a>';
			$login	= (WIKI_LOCKED)? '----' : $login;
			$load	= ($this->wiki->state && !LOAD_LOCKED)? '<a href="?load" title="'.INFOBULLE_LOAD.'">load</a>' : '----';
			$skin	= ($this->wiki->state && !SKIN_LOCKED)? '<a href="?skin" title="'.INFOBULLE_SKIN.'">skin</a>' : '----';
			$instal = ($this->wiki->state)? 
			'<a href="http://amartyfree.free.fr/epsilonwiki/archive.zip" title="'.INFOBULLE_INSTAL.'">'.VERSION.'</a>' : VERSION;		
		}
		$portal = '<a href="'.PORTAL_LINK.'" title="'.INFOBULLE_PORTAL.'">help</a>';
		$chaine = '<a href="'."javascript:montrer('foot_info')".'">epsilonwiki</a><div class="note" id="foot_info">'
				.$portal.' | '.$login.' | '.$load.' | '.$skin.' | '.$instal.'</div>';
		$info = (isset($_GET['fromsave']))? $this->wiki->doControlName( $_GET['fromsave'] ) : '';
		$nojavascript = '<noscript><div>'.INFO_NOSCRIPT.'</div></noscript>';
		return $chaine.' '.$info.' '.$nojavascript;
	}
}
class page_view extends wiki_page
{	function doTitle($active)
	{	return parent::doTitle($active).$this->page;
	}
	function doMenu()
	{	$edit = ($this->wiki->state)?	
				' <a href="?edit='.$this->page.'" title="'.INFOBULLE_EDIT.'">edit</a>' : '----';
		return parent::doMenu().$edit;
	}
	function doContent()
	{	$content = (file_exists(PAGES_DIR.$this->page.'.txt'))? file_get_contents(PAGES_DIR.$this->page.'.txt') : NEW_PAGE;
		$content = $this->wiki->doControlContent( $content );
		$content = $this->wiki->doSyntax($content);
		return $content.'<div style="clear:both;">&nbsp;</div>';
	}
}
class page_edit extends wiki_page
{	function doTitle($active)
	{	return parent::doTitle($active).' '.EDITING.' [ '.$this->page.' ]';
	}
	function doMenu()
	{	$menu = parent::doMenu();
		$menu .= '<form style="display:inline;" action="?save='.$this->page
		.'" method="post" enctype="multipart/form-data" onsubmit="return horse();">'
		.'<input type="submit" value="save" accesskey="s" id="submit" title="'.INFOBULLE_SAVE.'" /> | '
		.'<input type="button" value="preview" accesskey="v" onclick="javascript:preview();" title="'.INFOBULLE_PREVIEW.'" /> | '
		.'<input type="button" value="cancel" accesskey="z" onclick="javascript:history.back();" title="'.INFOBULLE_CANCEL.'" />';
		return $menu;
	}
	function doContent()
	{	$content = (file_exists(PAGES_DIR.$this->page.'.txt'))? file_get_contents(PAGES_DIR.$this->page.'.txt') : NEW_PAGE;
		$content = $this->wiki->doControlContent( $content );
		$preview = '<div id="preview">'.$this->wiki->doPreview($content).'</div>';	// n'existe que dans Edit
		$content = $preview.'<textarea name="content">'.$content.'</textarea></form>';
		return $content;
	}
}
class page_save extends wiki_page
{	function doContent()
	{	if (!isset($_POST['content']))
			$info ='';
		else
		{	$content = $this->wiki->doControlContent( $_POST['content'] );
			$IP = (preg_match('/^(\d{1,3}\.){3}\d{1,3}$/', $_SERVER['REMOTE_ADDR']))? $_SERVER['REMOTE_ADDR'] : ' IP intrusion';
			$mypage = PAGES_DIR.$this->page.'.txt';
			$OK1 = false; $OK2 = false;
			if (($p_mypage = fopen($mypage, 'w+')) && is_writable($mypage))
			{	$bytes = fwrite($p_mypage, $content);
				fclose($p_mypage);
				if (RSS_OK)
					$this->wiki->doRSS( $this->page, $content );	
				$OK1 = true;
				if (HISTORY_DIR <> '')
				{	$history_page = HISTORY_DIR.$this->page."/";
					if (!is_dir($history_page))
						mkdir($history_page);
					$mybackup = $history_page . date("Ymd-His", mktime(date("H"))) . ".txt";
					if (($p_mybackup = fopen($mybackup, "a")) && is_writable($mybackup))
					{	$content = date("Y/m/d H:i:s", mktime(date("H"))) . " | (" . $IP . ") \n" . $content;
						fwrite($p_mybackup, $content);
						fclose($p_mybackup);
						$OK2 = true;
					}
				}	
			}
			$temp = ($OK2)? '' : WITHOUT_HISTORY;
			$info = ($OK1)? $bytes.BYTES_SAVED.$temp.BY.$IP : $this->page.NOT_SAVED;
		}
		header( "location: index.php?view=".$this->page."&fromsave=".$info );
	}
}
class page_liste extends wiki_page
{	function doTitle($active)
	{	return parent::doTitle($active).$this->page;
	}
	function doContent()
	{	$dir = opendir(getcwd().'/'.PAGES_DIR);
		while ($file = readdir($dir))
			if (ereg( '.txt', $file))
				$tab[] = filemtime(PAGES_DIR.$file).'|'.$file;
		closedir($dir);
		$liste = '';
		if (isset($tab) && is_array($tab))
		{	rsort($tab);
			$liste .= '<ul>';
			for ($i=0; $i<count($tab); $i++)
			{	$temp = explode('|', $tab[$i]);
				$page = substr( $temp[1], 0, strlen($temp[1]) - 4 );
				$liste .= '<li>[<a href="index.php?history='.$page.'" title="'
					.INFOBULLE_HISTORY_DISPLAY.'">'.strftime('%d/%m/%y %R', $temp[0]).'</a>] '
					.'/ <a href="index.php?view='.$page.'" title="'.INFOBULLE_PAGE_DISPLAY.'">'.$page.'</a></li>';
			}
			$liste .= '</ul>';
		}
		else
			$liste .= WIKI_EMPTY;
		return $liste;
	}
}
class page_history extends wiki_page
{	function doTitle($active)
	{	return parent::doTitle($active).TITLE_HISTORY.' ['.$this->page.']';
	}
	function doContent()
	{	$dir = opendir(getcwd().'/'.HISTORY_DIR.$this->page);
		while ($file = readdir($dir))
			if (ereg( '.txt', $file))
				$tab[] = $file;
		closedir($dir);
		$liste = '';
		if (isset($tab) && is_array($tab))
		{	rsort($tab);
			$liste .= '<ul>';
			$N = count($tab);
			for ($i=0; $i<$N; $i++) 
			{	$handle = fopen( HISTORY_DIR.$this->page.'/'.$tab[$i], 'r' );
				$ligne_1 =  fgets( $handle, 256 );
				fclose( $handle );
				$temp = explode('|', $ligne_1);
				$date = trim( $temp[0] );
				$IP = trim( $temp[1] );
				$user_ID = (count($temp)>2)? trim( $temp[2] ) : '-';
				$IP = substr( $IP, 1, strlen($IP)-2 );
				$num = ($N-$i<10)? '0'.($N-$i) : $N-$i;
				$liste .=  '<li>'.$num.' : <a href="'.HISTORY_DIR.$this->page.'/'.$tab[$i]
					.'" title="'.INFOBULLE_PAGE_HISTORY_OPEN.'" >'
					.substr( $tab[$i], 0, strlen($tab[$i]) - 4 ).'</a> ('.$IP.')</li>';
			}
			$liste .= '</ul>';
		}
		else
			$liste .= HISTORY_EMPTY;
		return $liste;
	}
}
class page_login extends wiki_page
{	function doTitle($active)
	{	return parent::doTitle($active).$this->page;
	}
	function doContent()
	{	if (isset($_POST['password']))							// si on vient du formulaire
		{	$password = $this->wiki->doControlName( $_POST['password'] );
			if ($password==PASSWORD)							// avec le bon mot de passe
				setcookie( LOGIN_COOKIE, CRYPTED_PASSWORD );	// on le mémorise dans un cookie
			else
				setcookie( LOGIN_COOKIE, "" );					// sinon on efface le cookie
			header( "location: index.php?login" );				// et on réaffiche la page login
		}
		else													// sinon on affiche le formulaire
		{	$content = '<form method="post" action="index.php?login'.'">'.LOGIN_PASSWORD
					.'<input type="password" name="password" value="" style="border:1px solid #400; background-color:#fff;" /> -> '
					.'<input type="submit" value="'.$this->page.'" name="login" title="'.INFOBULLE_VALIDATE.'" /></p></form>';
			return $content;
		}
	}
}
class page_search extends wiki_page
{	function doTitle($active)
	{	return parent::doTitle($active).$this->page;
	}
	function doMenu()
	{	$menu = '<a href="?liste" title="'.INFOBULLE_LIST.'">liste</a> | ';
		$menu .= $this->wiki->doQuery($this->page);	// pour cohérence !!
		return $menu;
	}
	function doContent()
	{	$search = $this->page;	// pour cohérence !!
		if ($search == '')
		{	$search = SEARCH_NOTHING;
			$result = '<h4>'.SEARCH_NOTHING_IS_NOWHERE.'</h4>';
		}
		else
		{	$dir = opendir(PAGES_DIR);
			$temp = '';
			while ($file = readdir($dir))
			{	if (preg_match('/.txt/', $file))
				{	$p_file = fopen(PAGES_DIR.$file, 'r');
					$content = fread($p_file, filesize(PAGES_DIR.$file));
					fclose($p_file);
					if (preg_match("/$search/i", $content) || preg_match("/$search/i", PAGES_DIR.$file))
					{	$file = substr($file, 0, strlen($file) - 4);
						$temp .= '<li><a href="?view='.$file.'">'.$file.'</a></li>';
					}
				}
			}
			$result = ($temp !='')? '<h4>'.$search.SEARCH_IS_IN_PAGES.'</h4><ol>'.$temp.'</ol>' 
									: '<h4>'.$search.SEARCH_IS_NOWHERE.'</h4>';
		}
		return $result;
	}
}
class page_load extends wiki_page
{	function doTitle($active)
	{	return parent::doTitle($active).$this->page;
	}
	function doContent()
	{	$size_max = intval(LOAD_SIZE_MAX)*1024;	// taille en octets
		$content = '<h3>'.LOAD.'</h3>'
				.'<p>'.LOAD_DESCRIPTION.LOAD_SIZE_MAX.' ko.</p><p></p>'
				.'<form enctype="multipart/form-data" action="" method="post" onsubmit="return horse();">'
				.'<input type="hidden" name="taille_max" value="'.($size_max*1024).'" />'
				.'<input type="hidden" name="phase" value="traitement" />'
				.'<div style="text-align:center; background-color:#fff; border:1px solid;">'
				.'<input type="file" name="le_fichier" size="35" maxlength="100" title="'.INFOBULLE_RECHERCHER.'" /></div>'
				.'<p><input type="submit" accesskey="s" value="'.LOAD_BUTTON.'" title="'.INFOBULLE_LANCER.'" /></p></form>';
		if( isset($_POST['phase']) && ('traitement' == $_POST['phase']) )
		{	// types valides : *.jpg ou *.jpeg, *.gif, *.png, *.pdf, *.zip
			$types = array( "image/jpeg", "image/jpg", "image/gif", "image/png", "application/pdf", "application/zip" );
			if (is_uploaded_file($_FILES['le_fichier']['tmp_name']))
			{	$basenom = basename( $_FILES['le_fichier']['name'] );	// le nom du fichier simple, ex image.jpg
				if ($_FILES['le_fichier']['size'] > $size_max)
					$content .= '<br />'.LOAD_ERR_1.' ('.$_FILES['le_fichier']['size'].'octets)';
				elseif ( !in_array( $_FILES['le_fichier']['type'], $types ) &&		// pas dans le type mime ET
						 !eregi( "\.(jpg|jpeg|gif|png|pdf|zip)$", $basenom ))		// pas la bonne extension
					$content .= '<br />'.LOAD_ERR_2;
				elseif ( eregi( "php", $basenom ) )									// on bloque tout nom contenant php !!
					$content .= '<br />'.LOAD_NO_PHP;
				elseif( !move_uploaded_file( $_FILES['le_fichier']['tmp_name'], LOAD_DIR . $basenom))
					$content .= '<br />'.LOAD_ERR_3;
				else	
					$content .= '<br />'.LOAD_OK.$basenom.' ('.$_FILES['le_fichier']['size'].'octets)';
			}
			else
				$content .= '<br /> Problemo con : '.$_FILES['le_fichier']['name'];
		}
		return $content;
	}		
}
class page_skin extends wiki_page
{	function doTitle($active)
	{	return parent::doTitle($active).$this->page;
	}
	function doContent()
	{	if( isset($_POST['phase']) && ('traitement' == $_POST['phase']) )
		{	$choix = $this->wiki->doControlName( $_POST['choix'] );
			if (!empty($choix))
			{	setcookie(LOGIN_COOKIE.'_skin', $choix);
			}
			header( "location: index.php?skin" );				// et on réaffiche la page login
		}
		else
		{	if (isset($_COOKIE[LOGIN_COOKIE.'_skin']))
				$choix = $_COOKIE[LOGIN_COOKIE.'_skin'];
			else
		//		$choix = 'fixed';	correction du 23/08/2007
				$choix = STYLE;
		}
		$nb = 0;
		if ( is_dir(MECA_DIR.SKINS_DIR)  && $themes_dir = @opendir(MECA_DIR.SKINS_DIR) )	// meca/skins/
		{	while ($dir = readdir($themes_dir) )
				if (is_dir(MECA_DIR.SKINS_DIR.$dir) && !eregi('\.', $dir) )	//
				{	$skin[$nb] = $dir;
					$nb++;
				}
			closedir($themes_dir);
		}
		$content = '<h5>'.SKIN_TITLE.$nb.'</h5>';
		$content .= '<form name="filtre" method="post"><input type="hidden" name="phase" value="traitement"><ol>';
		for($i=0;$i<$nb;$i++)
			$content  .= '<li><input type="radio" name="choix" value="'.$skin[$i].'" '
					. (($choix==$skin[$i])? 'checked="true"' : '') .' /> '.$skin[$i].'</li>'; 
		$content .= '</ol><p><input type="submit" value="'.SKIN_BUTTON.'" title="'.SKIN_INFOBULLE.'" /></p></form>';
		return $content;
	}
}

?>